#!/usr/bin/env bash
#
# This small script is used in Makefile
# It tries to find a Fortran compiler
#

CC="gcc"
CXX="g++"
FC="gfortran"

LOCAL_GCC=`ls /usr/local/bin/gcc?? 2>/dev/null | tail -n1`
if [ "$LOCAL_GCC" != "" ];then
 if [ -x "$LOCAL_GCC" ];then
  CC="$LOCAL_GCC"
  LOCAL_GFORTRAN=`ls /usr/local/bin/gfortran?? | tail -n1`
  if [ -x "$LOCAL_GFORTRAN" ];then
   FC="$LOCAL_GFORTRAN"
   if [ "$0" = "lib/find_gcc_compiler.sh" ];then
    echo "$CC"
   elif [ "$0" = "lib/find_cpp_compiler.sh" ];then
    LOCAL_CXX=`ls /usr/local/bin/g++?? | tail -n1`
    if [ -x "$LOCAL_CXX" ];then
     CXX="$LOCAL_CXX"
    fi
    echo "$CXX"
   else
    echo "$FC"
   fi
   exit 0 # we are OK
  else
   # No local gfortran - don't use local gcc
   CC="gcc"
  fi
 fi
fi

GCC_MAJOR_VERSION=`$CC -dumpversion | cut -f1 -d.`
if [ $GCC_MAJOR_VERSION -lt 4 ];then
 FC="g77"
else
 FC="gfortran"
 # Do not perform gcc/g77 versions match check - it's too complex and who needs gcc-3.x anyway?
fi

if [ "$0" = "lib/find_gcc_compiler.sh" ];then
 echo "$CC"
elif [ "$0" = "lib/find_cpp_compiler.sh" ];then
 echo "$CXX"
else
 echo "$FC"
fi
