#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <getopt.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <sys/wait.h>
#include <sys/time.h>
#include <sys/resource.h>
              
#include "cpgplot.h"

#include "setenv_local_pgplot.h"

#include "limits.h"

//#include "get_number_of_measured_images_from_vast_summary_log.h"

/*

From http://www.cse.iitb.ac.in/~cs101/2003.2/resources/notesPgplot/chapter5.html

Table 5.1. Default Color Representation

Color
Index    Color                  (H, L, S)        (R, G, B)

 0   Black (background)       0, 0.00, 0.00   0.00, 0.00, 0.00
 1   White (default)          0, 1.00, 0.00   1.00, 1.00, 1.00
 2   Red                    120, 0.50, 1.00   1.00, 0.00, 0.00
 3   Green                  240, 0.50, 1.00   0.00, 1.00, 0.00
 4   Blue                     0, 0.50, 1.00   0.00, 0.00, 1.00
 5   Cyan (Green + Blue)    300, 0.50, 1.00   0.00, 1.00, 1.00
 6   Magenta (Red + Blue)    60, 0.50, 1.00   1.00, 0.00, 1.00
 7   Yellow  (Red + Green)  180, 0.50, 1.00   1.00, 1.00, 0.00
 8   Red + Yellow (Orange)  150, 0.50, 1.00   1.00, 0.50, 0.00
 9   Green + Yellow         210, 0.50, 1.00   0.50, 1.00, 0.00
10   Green + Cyan           270, 0.50, 1.00   0.00, 1.00, 0.50
11   Blue + Cyan            330, 0.50, 1.00   0.00, 0.50, 1.00
12   Blue + Magenta          30, 0.50, 1.00   0.50, 0.00, 1.00
13   Red + Magenta           90, 0.50, 1.00   1.00, 0.00, 0.50
14   Dark Gray                0, 0.33, 0.00   0.33, 0.33, 0.33
15   Light Gray   	      0, 0.66, 0.00   0.66, 0.66, 0.66
16--255	Undefined                    	                      

*/


float myfmin(float x, float y){
 if( x>y )
  return y;
 else
  return x; 
}

float myfmax(float x, float y){
 if( x>y )
  return x;
 else
  return y; 
}


void call_scripts(int period_search_switch){
 char cmd[512];
 strcpy(cmd, "util/nopgplot.sh");
 if(period_search_switch==1)strcat(cmd," -t");
 system(cmd);
 return;
}


int find_closest(float *x, float *y, float *X, float *Y,int N, float new_X1, float new_X2, float new_Y1, float new_Y2){
 float y_to_x_scaling_factor=fabsf(new_X2-new_X1)/fabsf(new_Y2-new_Y1);
 int i;
 float best_dist;
 float best_x,best_y;
 best_x=X[0];best_y=Y[0];
 int best_dist_num=0;
 best_dist=((*x)-X[0])*((*x)-X[0])+((*y)-Y[0])*((*y)-Y[0])*y_to_x_scaling_factor*y_to_x_scaling_factor; //!!
 for(i=1;i<N;i++){
  if( ((*x)-X[i])*((*x)-X[i])+((*y)-Y[i])*((*y)-Y[i])*y_to_x_scaling_factor*y_to_x_scaling_factor<best_dist ){
   best_dist=((*x)-X[i])*((*x)-X[i])+((*y)-Y[i])*((*y)-Y[i])*y_to_x_scaling_factor*y_to_x_scaling_factor;
   best_x=X[i];
   best_y=Y[i];
   best_dist_num=i; 
  }
 }
 (*x)=best_x;
 (*y)=best_y;
 return best_dist_num;   
}

/*
void save_viewed_star_mark(float mag_viewed, float sigma_viewed){
 FILE *f;
 f=fopen("vast_viewed_lightcurves.log","a");
 if(f==NULL){fprintf(stderr,"WARNING: cannot append to vast_viewed_lightcurves.log\n");return;}
 fprintf(f,"%10.6f %.6f\n",mag_viewed,sigma_viewed);
 fclose(f);
 return;
}

void load_viewed_star_mark(float *mag_viewed, float *sigma_viewed, int * Nstar_viewed, int Max_number_of_lines){
 FILE *f;
 f=fopen("vast_viewed_lightcurves.log","r");
 if(f==NULL)return;
 (*Nstar_viewed)=0;
 while(0<fscanf(f,"%f %f",&mag_viewed[(*Nstar_viewed)],&sigma_viewed[(*Nstar_viewed)])){
  (*Nstar_viewed)++;
  if( (*Nstar_viewed)>=Max_number_of_lines )break; // make sure we will not go overboard with the markers
 }
 fclose(f);
 return;
}
*/   

/*
void save_viewed_star_number(int viewed_star_number){
 FILE *f;
 f=fopen("vast_viewed_lightcurves.log","a");
 if(f==NULL){fprintf(stderr,"WARNING: cannot append to vast_viewed_lightcurves.log\n");return;}
 fprintf(f,"%d\n",viewed_star_number);
 fclose(f);
 return;
}

void load_viewed_star_numbers(char * mark_as_viewed, int Max_number_of_lines){
 FILE *f;
 f=fopen("vast_viewed_lightcurves.log","r");
 int star_number;
 if(f==NULL)return;
 while(0<fscanf(f,"%d",&star_number)){
//  (*Nstar_viewed)++;
  if( star_number>=Max_number_of_lines )continue; // make sure we will not go overboard with the markers
  mark_as_viewed[star_number]=1;
 }
 fclose(f);
 return;
}
*/


void save_viewed_star_number(char * viewed_star_outfilename){
 FILE *f;
 f=fopen("vast_viewed_lightcurves.log","a");
 if(f==NULL){fprintf(stderr,"WARNING: cannot append to vast_viewed_lightcurves.log\n");return;}
 fprintf(f,"%s\n",viewed_star_outfilename);
 fclose(f);
 return;
}

void load_viewed_star_numbers(char * mark_as_viewed, int Max_number_of_lines, char **outfilename){
 FILE *f;
 int i;
 f=fopen("vast_viewed_lightcurves.log","r");
 char star[OUTFILENAME_LENGTH];
 if(f==NULL)return;
 while(0<fscanf(f,"%s",star)){
  for(i=0;i<Max_number_of_lines;i++){
   if( mark_as_viewed[i]==1 )continue;
   if( 0==strncmp(star,outfilename[i],OUTFILENAME_LENGTH) ){
    mark_as_viewed[i]=1;
    break;
   }
  }
 }
 fclose(f);
 return;
}

void load_candidate_star_numbers(char * mark_as_candidate, int Max_number_of_lines, char **outfilename){
 FILE *f;
 int i;
 f=fopen("vast_autocandidates.log","r");
 char star[OUTFILENAME_LENGTH];
 if(f==NULL)return;
 while(0<fscanf(f,"%s",star)){
  for(i=0;i<Max_number_of_lines;i++){
   if( mark_as_candidate[i]==1 )continue;
   if( 0==strncmp(star,outfilename[i],OUTFILENAME_LENGTH) ){
    mark_as_candidate[i]=1;
    break;
   }
  }
 }
 fclose(f);
 return;
}



int main(int argc, char **argv){
 char COMMAND_STR[512];
 //float *cand_mag=NULL;
 //float *cand_sigma=NULL;
 //int Ncanstar=0;
 FILE *datamsigma_file;
 float *mag=NULL;
 float *sigma=NULL;
 float *X=NULL;
 float *Y=NULL;
 char **outfilename=NULL;
 int Nstar=0;
 int i;//,j;
 //
 float * modified_sigma=NULL;
 char * mark_as_viewed=NULL;
 char * mark_as_candidate=NULL;
 char *mark_as_last_viewed=NULL;
 float * plot_x;
 float * plot_y;
 //
 float maxSIGMA,minSIGMA,maxM,minM;
 //
 float max_modifiedSIGMA,min_modifiedSIGMA;
 /* PGPLOT vars */
 float curX=0.0;
 float curY=0.0;
 char curC='R';
 /* for zoom */
 float draw_X_min,draw_X_max,draw_X_min_current,draw_X_max_current;
 float draw_Y_min,draw_Y_max,draw_Y_min_current,draw_Y_max_current; 
 float curX2,curY2;
 /* ----------- */
 //float *mag2=NULL;
 //float *sigma2=NULL;
 //float *X2=NULL;
 //float *Y2=NULL;
 //char **outfilename2=NULL;
 //int Nstar2=0;
 /* ----------- */
 //float *mag3=NULL;
 //float *sigma3=NULL;
 //float *X3=NULL;
 //float *Y3=NULL;
 //char **outfilename3=NULL;
 //int Nstar3=0;
 /* ----------- */
 float *mag_viewed=NULL;
 float *sigma_viewed=NULL;
 float *skewness=NULL;
 float *kurtosis=NULL;
 float max_skewness,min_skewness;
 float max_kurtosis,min_kurtosis;

 float * I = NULL;
 float * J = NULL;
 float * K = NULL;
 float * L = NULL;
 float max_I,max_J,max_K,max_L;
 float min_I,min_J,min_K,min_L;

 float * MAD_scaled_to_sigma = NULL;

 int * points_in_lightcurve = NULL;
 
 float * lag1_autocorrelation  = NULL;
 float * RoMS = NULL;
 float * Chi2 = NULL;
 float * I_sign_only = NULL;
 float * AGN_v = NULL;
 
 float max_lag1_autocorrelation;
 float max_RoMS;
 float max_Chi2;
 float max_I_sign_only;
 float max_AGN_v;
 
 float min_lag1_autocorrelation;
 float min_RoMS;
 float min_Chi2;
 float min_I_sign_only;
 float min_AGN_v;
 
 
 //int Nstar_viewed=0;
 
 int status=0; // for wait()

 //fprintf(stderr,"DEBUGA01\n");

 /* header string */
 char header_str[512];

 /* Variables needed to draw the curve deviding stars with high (spspected 
    variability candidates) and low sigma. */
 float * high_sigma_curve_mag;
 float * high_sigma_curve_limit; // actual cut-off level at a given magnitude
 int sigma_curve_N_points=0;
 FILE *vast_sigma_selection_curve_file;
 
 float * high_sigma_curve_limit_modified_sigma; //
 float * high_sigma_curve_limit_I; //
 float * high_sigma_curve_limit_L; //
 
 /* Mark the last inspected star */
 float markX=0.0;
 float markY=0.0; 

 /* Closest star */
 int closest_star_number;
 float closest_star_x;
 float closest_star_y;


 /* Protection against strange free() crushes */
 //setenv("MALLOC_CHECK_", "0", 1);

 int use_old_files=0;
 int t_option_set=0;
 int use_ds9_instead_of_pgfv=0;
 
 int display_mode=1; // 1 - mag-sigma plot
                     // 2 - mag-modified_sigma plot
                     // 3 - Stetson's L index
                     // 4 - RoMS
                     // 5 - (Max-Min)/(Max+Min) 


 char instrumental_magnitude_or_magnitude_string[256];

 //int number_of_stars = MIN(get_number_of_measured_images_from_vast_summary_log(),MAX_NUMBER_OF_STARS);
 
 //fprintf(stderr,"DEBUGA02\n");
 
 /* Options for getopt() */
 int n;
 const char* const shortopt = "t9";
 const struct option longopt[] = { {"ds9", 0, NULL, '9'}, {"tsearch", 0, NULL, 't'}, {NULL, 0, NULL, 0} }; //NULL string must be in the end                                 
 int nextopt;
 while (nextopt = getopt_long(argc, argv, shortopt, longopt, NULL), nextopt != -1) {
  switch (nextopt) {
    case '9':
     use_ds9_instead_of_pgfv=1;
     break;  
    case 't':
     t_option_set=1;
    case  -1:
     fprintf(stderr, "That's all with options\n");
     break;
  }
 }

 /* if there are some more option - use old files */
 for (n = optind; n < argc; n++) {
   use_old_files=1;
   fprintf(stderr,"Using old files.\n");
 }
 
 //fprintf(stderr,"DEBUG-1\n");
 
 /* else - call external scripts to produce data files */
 if( t_option_set==0 && use_old_files==0 ){
  call_scripts(0); //, bin_dir_name); /* Do not use period search */
 }
 if( t_option_set==1 && use_old_files==0 ){
  call_scripts(1); //, bin_dir_name); /* Use period search */
 }

 //fprintf(stderr,"DEBUG00\n");
  
 /* read data.m_sigma file */ 
 datamsigma_file=fopen("vast_lightcurve_statistics.log","r");
 if( datamsigma_file==NULL ){
  fprintf(stderr,"ERROR: Can't open file \"vast_lightcurve_statistics.log\"!\n");
  exit(1);
 }
 do{
  mark_as_viewed=realloc(mark_as_viewed,(Nstar+1)*sizeof(char));
  mark_as_viewed[Nstar]=0; // initialize
  mark_as_candidate=realloc(mark_as_candidate,(Nstar+1)*sizeof(char));
  mark_as_candidate[Nstar]=0; // initialize
  mark_as_last_viewed=realloc(mark_as_last_viewed,(Nstar+1)*sizeof(char));
  mark_as_last_viewed[Nstar]=0; // initialize
  modified_sigma=realloc(modified_sigma,(Nstar+1)*sizeof(float));
  sigma=realloc(sigma,(Nstar+1)*sizeof(float));
  mag=realloc(mag,(Nstar+1)*sizeof(float));
  skewness=realloc(skewness,(Nstar+1)*sizeof(float));
  kurtosis=realloc(kurtosis,(Nstar+1)*sizeof(float)); 
  
  I=realloc(I,(Nstar+1)*sizeof(float));
  J=realloc(J,(Nstar+1)*sizeof(float));
  K=realloc(K,(Nstar+1)*sizeof(float));
  L=realloc(L,(Nstar+1)*sizeof(float));
  
  points_in_lightcurve=realloc(points_in_lightcurve,(Nstar+1)*sizeof(int));
  MAD_scaled_to_sigma=realloc(MAD_scaled_to_sigma,(Nstar+1)*sizeof(float));
  
  lag1_autocorrelation=realloc(lag1_autocorrelation,(Nstar+1)*sizeof(float));
  RoMS=realloc(RoMS,(Nstar+1)*sizeof(float));
  Chi2=realloc(Chi2,(Nstar+1)*sizeof(float));
  I_sign_only=realloc(I_sign_only,(Nstar+1)*sizeof(float));
  AGN_v=realloc(AGN_v,(Nstar+1)*sizeof(float));
  
  X=realloc(X,(Nstar+1)*sizeof(float));
  Y=realloc(Y,(Nstar+1)*sizeof(float));
  outfilename=realloc(outfilename,(Nstar+1)*sizeof(char *));
  outfilename[Nstar]=malloc(OUTFILENAME_LENGTH*sizeof(char));
  if( outfilename[Nstar]==NULL ){fprintf(stderr,"ERROR: can't allocate memory for outfilename[Nstar]!\n");return 1;}
  Nstar++;
  ///
  //fprintf(stderr,"OK %d\n",Nstar);
  //if( Nstar>1 )fprintf(stderr,"%f %f %f %f %s  %f  %f %f  %f %f %f %f %d %f\n",mag[Nstar-2],sigma[Nstar-2],X[Nstar-2],Y[Nstar-2],outfilename[Nstar-2], modified_sigma[Nstar-2],skewness[Nstar-2],kurtosis[Nstar-2],I[Nstar-2],J[Nstar-2],K[Nstar-2],L[Nstar-2], points_in_lightcurve[Nstar-2], MAD_scaled_to_sigma[Nstar-2]);
  //
 }while( -1<fscanf(datamsigma_file,"%f %f %f %f %s  %f  %f %f  %f %f %f %f %d %f %f %f %f %f %f",&mag[Nstar-1],&sigma[Nstar-1],&X[Nstar-1],&Y[Nstar-1],outfilename[Nstar-1], &modified_sigma[Nstar-1],&skewness[Nstar-1],&kurtosis[Nstar-1],&I[Nstar-1],&J[Nstar-1],&K[Nstar-1],&L[Nstar-1], &points_in_lightcurve[Nstar-1], &MAD_scaled_to_sigma[Nstar-1], &lag1_autocorrelation[Nstar-1], &RoMS[Nstar-1], &Chi2[Nstar-1], &I_sign_only[Nstar-1], &AGN_v[Nstar-1] ) );
 fclose(datamsigma_file);
 Nstar--;
 
 //fprintf(stderr,"AGA %d\n",Nstar);
 
 mag_viewed=malloc(3*Nstar*sizeof(float));
 sigma_viewed=malloc(3*Nstar*sizeof(float));

 /*  Load the curve indicating stars with high (suspected 
     variability candidates) and low sigma from vast_sigma_selection_curve.log . */
 vast_sigma_selection_curve_file=fopen("vast_sigma_selection_curve.log","r");
 if( vast_sigma_selection_curve_file!=NULL ){
  high_sigma_curve_mag=malloc(sizeof(float)*MAX_NUMBER_OF_STARS);
  high_sigma_curve_limit=malloc(sizeof(float)*MAX_NUMBER_OF_STARS);
  high_sigma_curve_limit_modified_sigma=malloc(sizeof(float)*MAX_NUMBER_OF_STARS);
  high_sigma_curve_limit_I=malloc(sizeof(float)*MAX_NUMBER_OF_STARS);
  high_sigma_curve_limit_L=malloc(sizeof(float)*MAX_NUMBER_OF_STARS);
  sigma_curve_N_points=0;
  while(-1<fscanf(vast_sigma_selection_curve_file,"%f %f %f %f %f",&high_sigma_curve_mag[sigma_curve_N_points],&high_sigma_curve_limit[sigma_curve_N_points],&high_sigma_curve_limit_modified_sigma[sigma_curve_N_points],&high_sigma_curve_limit_I[sigma_curve_N_points],&high_sigma_curve_limit_L[sigma_curve_N_points])){
   sigma_curve_N_points++;
  }
  fclose(vast_sigma_selection_curve_file);
 }
 
 //fprintf(stderr,"DEBUG02\n");
 
 // Load markers
 if( use_old_files==1 )load_viewed_star_numbers( mark_as_viewed, Nstar, outfilename);
 
 load_candidate_star_numbers( mark_as_candidate, Nstar, outfilename);
 
 // find limits //
 maxM=minM=mag[0];
 maxSIGMA=minSIGMA=sigma[0];
 max_modifiedSIGMA=min_modifiedSIGMA=modified_sigma[0];
 max_skewness=min_skewness=skewness[0];
 max_kurtosis=min_kurtosis=kurtosis[0];
 max_I=min_I=I[0];
 max_J=min_J=J[0];
 max_K=min_K=K[0];
 max_L=min_L=L[0];

 max_lag1_autocorrelation=min_lag1_autocorrelation=lag1_autocorrelation[0];
 max_RoMS=min_RoMS=RoMS[0];
 max_Chi2=min_Chi2=Chi2[0];
 max_I_sign_only=min_I_sign_only=I_sign_only[0];
 max_AGN_v=min_AGN_v=AGN_v[0];
 

 
 // start with [1] since we use [0] as the default value
 for(i=1;i<Nstar;i++){
 
  if( mag[i]>maxM )maxM=mag[i];
  if( mag[i]<minM )minM=mag[i];

  if( sigma[i]>maxSIGMA )maxSIGMA=sigma[i];
  if( sigma[i]<minSIGMA )minSIGMA=sigma[i];

  if( modified_sigma[i]>max_modifiedSIGMA )max_modifiedSIGMA=modified_sigma[i];
  if( modified_sigma[i]<min_modifiedSIGMA )min_modifiedSIGMA=modified_sigma[i];
  
  if( skewness[i]>max_skewness )max_skewness=skewness[i];
  if( skewness[i]<min_skewness )min_skewness=skewness[i];
  
  if( kurtosis[i]>max_kurtosis )max_kurtosis=kurtosis[i];
  if( kurtosis[i]<min_kurtosis )min_kurtosis=kurtosis[i];
 
  if( I[i]>max_I )max_I=I[i];
  if( I[i]<min_I )min_I=I[i];
  
  if( J[i]>max_J )max_J=J[i];
  if( J[i]<min_J )min_J=J[i];
  
  if( K[i]>max_K )max_K=K[i];
  if( K[i]<min_K )min_K=K[i];
  
  if( L[i]>max_L )max_L=L[i];
  if( L[i]<min_L )min_L=L[i];
  
  if( lag1_autocorrelation[i]>max_lag1_autocorrelation )max_lag1_autocorrelation=lag1_autocorrelation[i];
  if( lag1_autocorrelation[i]<min_lag1_autocorrelation )min_lag1_autocorrelation=lag1_autocorrelation[i];

  if( RoMS[i]>max_RoMS )max_RoMS=RoMS[i];
  if( RoMS[i]<min_RoMS )min_RoMS=RoMS[i];
  
  if( Chi2[i]>max_Chi2 )max_Chi2=Chi2[i];
  if( Chi2[i]<min_Chi2 )min_Chi2=Chi2[i];
  
  if( I_sign_only[i]>max_I_sign_only )max_I_sign_only=I_sign_only[i];
  if( I_sign_only[i]<min_I_sign_only )min_I_sign_only=I_sign_only[i];
  
  if( AGN_v[i]>max_AGN_v )max_AGN_v=AGN_v[i];
  if( AGN_v[i]<min_AGN_v )min_AGN_v=AGN_v[i];
  
  //fprintf(stderr,"I[%d]=%f max_I=%f min_I=%f\n",i,I[i],max_I,min_I);
  
 }
 
 if( minM>0.0 && maxM>0.0 )
  strncpy(instrumental_magnitude_or_magnitude_string,"Magnitude",256);
 else
  strncpy(instrumental_magnitude_or_magnitude_string,"Instrumental magnitude",256);
 instrumental_magnitude_or_magnitude_string[255]='\0'; // just in case
 
 // This should be sufficeint to setup a mag-sigma plot
 draw_X_min=minM-(maxM-minM)/10;
 draw_X_max=maxM+(maxM-minM)/10;
 draw_X_min_current=draw_X_min;
 draw_X_max_current=draw_X_max;
 
 draw_Y_min=minSIGMA-(maxSIGMA-minSIGMA)/10;
 draw_Y_max=maxSIGMA+(maxSIGMA-minSIGMA)/10;
 draw_Y_min_current=draw_Y_min;
 draw_Y_max_current=draw_Y_max;

 plot_x=mag;plot_y=sigma; // display_mode==1
 ///////////////////////////////////////////////////////
 
 /* draw picture */
 //setenv("PGPLOT_DIR","lib/pgplot/",1);
 setenv_localpgplot(argv[0]);
 fprintf(stderr,"\nStarting PGPlot ");  
 if( 1!=cpgbeg(0, "/XW", 1, 1) )
  return EXIT_FAILURE;
 cpgask(0); // turn OFF this silly " Type <RETURN> for next page:" request
 fprintf(stderr,"- Ok\n");
 
 fprintf(stderr,"\nClick on any star to see its lightcurve.\n");
 fprintf(stderr,"Press \033[0;36m'M'\033[00m and \033[0;36m'N'\033[00m to switch between the various statistic displays.\nPress 'Z' and draw rectangle to zoom in.\nPress 'D', 'Z''Z' or click middle mouse button to return to the original zoom.\nPress 'X' two times or double right click to exit.\nHave fun! :)\n\n");
  
 // reset
 //for(i=0;i<Nstar;i++)mark_as_last_viewed[i]=0;

 do{ 
 
  cpgscr( 0, 0.10, 0.31, 0.32);  /* set default vast window background */
  cpgeras();
  cpgsvp(0.08, 0.95, 0.1, 0.92);
  cpgswin(draw_X_min_current, draw_X_max_current, draw_Y_min_current, draw_Y_max_current);
  cpgsci(0);
  cpgscr( 0, 0.08, 0.08, 0.09);  /* set background */
  if( draw_X_min_current!=draw_X_max_current && draw_Y_min_current!=draw_Y_max_current )
   cpgrect(draw_X_min_current, draw_X_max_current, draw_Y_min_current, draw_Y_max_current); /* draw background for plot */
  else
   cpgrect(draw_X_min, draw_X_max, draw_Y_min, draw_Y_max); /* draw background for plot */
  cpgsci(1);
  cpgbox("BCNST1", 0.0 , 0, "BCNST1", 0.0, 0);

  // If we have maagnitude as one axis
  if( display_mode==1 || display_mode==2 || display_mode==3 || display_mode==4 || display_mode==5 ){
   cpgsch(0.85); /* make this labels with smaller characters */ 
   cpgmtxt( "B", 2.5, 0.0, 0.0, "(bright stars)");
   cpgmtxt( "B", 2.5, 1.0, 1.0, "(faint stars)");
  }
 /*
  if( display_mode==5 ){
   cpgsch(0.85); // make this labels with smaller characters 
   cpgmtxt( "B", 2.5, 0.0, 0.0, "(many bright points)");
   cpgmtxt( "B", 2.5, 1.0, 1.0, "(many faint points)");
  }
 */  
 
  cpgscf(1);
  cpgsch(1.1); /* make labels with larger characters */
  cpgscr( 1, 0.62, 0.81, 0.38); /* set color of lables */
  sprintf(header_str,"Stars measured: %d", Nstar);
  if( display_mode==1 )
   cpglab(instrumental_magnitude_or_magnitude_string, "Standard deviation", header_str);
  if( display_mode==2 )
   cpglab(instrumental_magnitude_or_magnitude_string, "Weighted standard deviation / number of points in lc", header_str);
  if( display_mode==3 )
   cpglab(instrumental_magnitude_or_magnitude_string, "Stetson varaibility index L", header_str);
  if( display_mode==4 )
   cpglab(instrumental_magnitude_or_magnitude_string, "RoMS", header_str);
  if( display_mode==5 )
   cpglab(instrumental_magnitude_or_magnitude_string, "(Max-Min) / (Max+Min)", header_str);
  if( display_mode==6 )
   cpglab(instrumental_magnitude_or_magnitude_string, "Welch-Stetson varaibility index I", header_str);
  if( display_mode==7 )
   cpglab("Skewness (\"asymmetry\")", "Kurtosis (\"peakedness\")", header_str);
  if( display_mode==8 )
   cpglab(instrumental_magnitude_or_magnitude_string, "Stetson varaibility index J", header_str);
  if( display_mode==9 )
   cpglab(instrumental_magnitude_or_magnitude_string, "Stetson varaibility index K", header_str);
  if( display_mode==10 )
   cpglab(instrumental_magnitude_or_magnitude_string, "Lag=1 autocorrelation", header_str);
  if( display_mode==11 )
   cpglab(instrumental_magnitude_or_magnitude_string, "reduced \\gx\\u2", header_str);
  if( display_mode==12 )
   cpglab(instrumental_magnitude_or_magnitude_string, "Sign-only variability index I", header_str);
  cpgscr( 1, 1.0, 1.0, 1.0);
  cpgsch(1.0);
  cpgsci(1);
  //cpgpt(Nstar, mag, sigma, 18); 
  //fprintf(stderr,"DEBUG04\n");
  cpgpt(Nstar, plot_x, plot_y, 18);
  //fprintf(stderr,"DEBUG05\n");
  //cpgscr( 1, 1.0, 1.0, 1.0); // set color index 1 to white
  
  // Mark candidate variable stars
  for(i=0;i<Nstar;i++){
   cpgsci(5); // Cyan
   if( mark_as_candidate[i]==1 ){
    cpgpt1( plot_x[i], plot_y[i], 18);
   }
  }

  // Mark previously viewed stars
  for(i=0;i<Nstar;i++){
   cpgsci(3); // Green
   if( mark_as_viewed[i]==1 ){
    cpgpt1( plot_x[i], plot_y[i], 18);
   }
  }

  //cpgsci(3); // Green
  //cpgpt(Nstar_viewed, mag_viewed, sigma_viewed, 18);
  
  // No idea what it was...
  //cpgsci(3); // Green
  //cpgpt(Ncanstar, cand_mag, cand_sigma, 2);

  //cpgsci(4); // Blue
  //cpgpt(Nstar2, mag2, sigma2, 4);
  //cpgsci(5); // Cyan (Green + Blue)
  //cpgpt(Nstar3, mag3, sigma3, 6);


  if( display_mode==1 || display_mode==2 || display_mode==3 ){
   // Draw the curve dividing stars with high (spspected 
   //   variability candidates) and low sigma. 
   if( sigma_curve_N_points!=0 ){
    cpgsci(6); // Magenta (Red + Blue)
    cpgsls(4); // dotted line
    if( display_mode==1 )
     cpgline(sigma_curve_N_points,high_sigma_curve_mag,high_sigma_curve_limit);
    if( display_mode==2 )
     cpgline(sigma_curve_N_points,high_sigma_curve_mag,high_sigma_curve_limit_modified_sigma);
    if( display_mode==3 )
     cpgline(sigma_curve_N_points,high_sigma_curve_mag,high_sigma_curve_limit_L);
    cpgsci(5); // set color index back to draw thouse nice blue rectangles %)
    cpgsls(1); // full line
   }
  }

  
  // Mark the previous viewed star 
  for(i=0;i<Nstar;i++){
   if( mark_as_last_viewed[i]==1 ){
    markX=plot_x[i];
    markY=plot_y[i];
//  if( markX!=0.0 && markY!=0.0 ){
    cpgsci(2);
    cpgpt1( markX, markY, 4);
    cpgsci(5);
//  }
   }
  }
  
  cpgcurs(&curX, &curY, &curC);
  if( curC=='X' || curC=='x' ){
   fprintf(stderr,"\nAre you sure you want to exit?\nIf yes, please click the right mouse button again (or press 'X')!\nOtherwise, press any key.\n");
   cpgcurs(&curX, &curY, &curC);
   if( curC=='X' || curC=='x' )
    break;
   //else
   // curC=' ';
  }

  // Check if the click is outside the plot 
  // (we'll just redraw the plot if it is)
  if( curC=='A' || curC=='a' ){
   if( curX<draw_X_min_current || curX>draw_X_max_current || curY<draw_Y_min_current || curY>draw_Y_max_current ){
    curC='R';
   }
  }

  if( curC=='A' || curC=='a' ){
   // find closest star to the cursor position
   closest_star_x=curX;
   closest_star_y=curY;
   //closest_star_number=find_closest(&closest_star_x,&closest_star_y,mag,sigma,Nstar,draw_X_min_current,draw_X_max_current,draw_Y_min_current,draw_Y_max_current);
   closest_star_number=find_closest(&closest_star_x,&closest_star_y,plot_x,plot_y,Nstar,draw_X_min_current,draw_X_max_current,draw_Y_min_current,draw_Y_max_current);
   // remember click position
   markX=closest_star_x;markY=closest_star_y;
   //if( Nstar_viewed>=Nstar )Nstar_viewed=0; // make sure we don't have too much stars in the viewed stars list
   //mag_viewed[Nstar_viewed]=markX;
   //sigma_viewed[Nstar_viewed]=markY;
   //save_viewed_star_mark( markX, markY); // save the marker
   //save_viewed_star_number(closest_star_number);
   save_viewed_star_number(outfilename[closest_star_number]);
   //Nstar_viewed++;
   for(i=0;i<Nstar;i++)mark_as_last_viewed[i]=0;
   mark_as_last_viewed[closest_star_number]=1;
   mark_as_viewed[closest_star_number]=1;
   //
   //sprintf(COMMAND_STR,"util/stat_outfile %s\n",outfilename[closest_star_number]);
   //fprintf(stderr,"%s",COMMAND_STR);
   //system(COMMAND_STR);
   if( use_ds9_instead_of_pgfv==1 )
    sprintf(COMMAND_STR,"./lc --ds9 %s\n", outfilename[closest_star_number]);
   else
    sprintf(COMMAND_STR,"./lc %s\n", outfilename[closest_star_number]);
   fprintf(stderr,"%s",COMMAND_STR);
   // fork before system() so the parent process is not blocked      
   if( 0==fork() ){sleep(1);system(COMMAND_STR);exit(0);}else{wait3(&status, WNOHANG, NULL);}
   //system(COMMAND_STR);
  }

  // Change display mode
  if( curC=='N' || curC=='n' ){
   display_mode--;display_mode--;
   if( display_mode<1 )display_mode=4;
   curC='M';
  }

  //
  //fprintf(stderr,"display_mode=%d\n",display_mode);

  // Change display mode
  if( curC=='M' || curC=='m' ){
   display_mode++;
   if( display_mode>5 )display_mode=1;

   //fprintf(stderr,"display_mode=%d\n",display_mode);

   if( display_mode==1 ){
    // This should be sufficeint to setup a mag-sigma plot
    draw_X_min=minM-(maxM-minM)/10;
    draw_X_max=maxM+(maxM-minM)/10;
    draw_X_min_current=draw_X_min;
    draw_X_max_current=draw_X_max;
 
    draw_Y_min=minSIGMA-(maxSIGMA-minSIGMA)/10;
    draw_Y_max=maxSIGMA+(maxSIGMA-minSIGMA)/10;
    draw_Y_min_current=draw_Y_min;
    draw_Y_max_current=draw_Y_max;

    plot_x=mag;plot_y=sigma; // display_mode==1
    ///////////////////////////////////////////////////////
   }  
   if( display_mode==2 ){
    // This should be sufficeint to setup a mag-modified_sigma plot
    draw_X_min=minM-(maxM-minM)/10;
    draw_X_max=maxM+(maxM-minM)/10;
    draw_X_min_current=draw_X_min;
    draw_X_max_current=draw_X_max;
 
    draw_Y_min=min_modifiedSIGMA-(max_modifiedSIGMA-min_modifiedSIGMA)/10;
    draw_Y_max=max_modifiedSIGMA+(max_modifiedSIGMA-min_modifiedSIGMA)/10;
    draw_Y_min_current=draw_Y_min;
    draw_Y_max_current=draw_Y_max;

    plot_x=mag;plot_y=modified_sigma; // display_mode==2
    ///////////////////////////////////////////////////////
   }  
   if( display_mode==3 ){
    // mag-L plot
    draw_X_min=minM-(maxM-minM)/10;
    draw_X_max=maxM+(maxM-minM)/10;
    draw_X_min_current=draw_X_min;
    draw_X_max_current=draw_X_max;
 
    draw_Y_min=min_L-(max_L-min_L)/10;
    draw_Y_max=max_L+(max_L-min_L)/10;
    draw_Y_min_current=draw_Y_min;
    draw_Y_max_current=draw_Y_max;

    plot_x=mag;plot_y=L; // display_mode==3
    ///////////////////////////////////////////////////////
   }  
   if( display_mode==4 ){
    // mag-RoMS plot
    draw_X_min=minM-(maxM-minM)/10;
    draw_X_max=maxM+(maxM-minM)/10;
    draw_X_min_current=draw_X_min;
    draw_X_max_current=draw_X_max;
 
    draw_Y_min=min_RoMS-(max_RoMS-min_RoMS)/10;
    draw_Y_max=max_RoMS+(max_RoMS-min_RoMS)/10;
    draw_Y_min_current=draw_Y_min;
    draw_Y_max_current=draw_Y_max;

    plot_x=mag;plot_y=RoMS; // display_mode==7
    ///////////////////////////////////////////////////////
   }  
   if( display_mode==5 ){
    // mag-AGN_index plot
    draw_X_min=minM-(maxM-minM)/10;
    draw_X_max=maxM+(maxM-minM)/10;
    draw_X_min_current=draw_X_min;
    draw_X_max_current=draw_X_max;
 
    draw_Y_min=min_AGN_v-(max_AGN_v-min_AGN_v)/10;
    draw_Y_max=max_AGN_v+(max_AGN_v-min_AGN_v)/10;
    draw_Y_min_current=draw_Y_min;
    draw_Y_max_current=draw_Y_max;

    plot_x=mag;plot_y=AGN_v; // display_mode==7
    ///////////////////////////////////////////////////////
   }  
   if( display_mode==6 ){
    // mag-I plot
    draw_X_min=minM-(maxM-minM)/10;
    draw_X_max=maxM+(maxM-minM)/10;
    draw_X_min_current=draw_X_min;
    draw_X_max_current=draw_X_max;
 
    draw_Y_min=min_I-(max_I-min_I)/10;
    draw_Y_max=max_I+(max_I-min_I)/10;
    draw_Y_min_current=draw_Y_min;
    draw_Y_max_current=draw_Y_max;

    plot_x=mag;plot_y=I; // display_mode==4
    ///////////////////////////////////////////////////////
   }  
   if( display_mode==7 ){
    // skewness-kurtosis plot
    draw_X_min=min_skewness-(max_skewness-min_skewness)/10;
    draw_X_max=max_skewness+(max_skewness-min_skewness)/10;
    draw_X_min_current=draw_X_min;
    draw_X_max_current=draw_X_max;
 
    draw_Y_min=min_kurtosis-(max_kurtosis-min_kurtosis)/10;
    draw_Y_max=max_kurtosis+(max_kurtosis-min_kurtosis)/10;
    draw_Y_min_current=draw_Y_min;
    draw_Y_max_current=draw_Y_max;

    plot_x=skewness;plot_y=kurtosis; // display_mode==5
    ///////////////////////////////////////////////////////
   }  
   if( display_mode==8 ){
    // mag-J plot
    draw_X_min=minM-(maxM-minM)/10;
    draw_X_max=maxM+(maxM-minM)/10;
    draw_X_min_current=draw_X_min;
    draw_X_max_current=draw_X_max;
 
    draw_Y_min=min_J-(max_J-min_J)/10;
    draw_Y_max=max_J+(max_J-min_J)/10;
    draw_Y_min_current=draw_Y_min;
    draw_Y_max_current=draw_Y_max;

    plot_x=mag;plot_y=J; // display_mode==6
    ///////////////////////////////////////////////////////
   }  
   if( display_mode==9 ){
    // mag-K plot
    draw_X_min=minM-(maxM-minM)/10;
    draw_X_max=maxM+(maxM-minM)/10;
    draw_X_min_current=draw_X_min;
    draw_X_max_current=draw_X_max;
 
    draw_Y_min=min_K-(max_K-min_K)/10;
    draw_Y_max=max_K+(max_K-min_K)/10;
    draw_Y_min_current=draw_Y_min;
    draw_Y_max_current=draw_Y_max;

    plot_x=mag;plot_y=K; // display_mode==7
    ///////////////////////////////////////////////////////
   }  
   if( display_mode==10 ){
    // mag-lag1_autocorrelation plot
    draw_X_min=minM-(maxM-minM)/10;
    draw_X_max=maxM+(maxM-minM)/10;
    draw_X_min_current=draw_X_min;
    draw_X_max_current=draw_X_max;
 
    draw_Y_min=min_lag1_autocorrelation-(max_lag1_autocorrelation-min_lag1_autocorrelation)/10;
    draw_Y_max=max_lag1_autocorrelation+(max_lag1_autocorrelation-min_lag1_autocorrelation)/10;
    draw_Y_min_current=draw_Y_min;
    draw_Y_max_current=draw_Y_max;

    plot_x=mag;plot_y=lag1_autocorrelation; // display_mode==7
    ///////////////////////////////////////////////////////
   }  
   if( display_mode==11 ){
    //display_mode++; // !!! diabled
    // mag-Chi2 plot
    draw_X_min=minM-(maxM-minM)/10;
    draw_X_max=maxM+(maxM-minM)/10;
    draw_X_min_current=draw_X_min;
    draw_X_max_current=draw_X_max;
 
    draw_Y_min=min_Chi2-(max_Chi2-min_Chi2)/10;
    draw_Y_max=max_Chi2+(max_Chi2-min_Chi2)/10;
    draw_Y_min_current=draw_Y_min;
    draw_Y_max_current=draw_Y_max;

    plot_x=mag;plot_y=Chi2; // display_mode==7
    ///////////////////////////////////////////////////////
   }  
   if( display_mode==12 ){
    // mag-I_sign_only plot
    draw_X_min=minM-(maxM-minM)/10;
    draw_X_max=maxM+(maxM-minM)/10;
    draw_X_min_current=draw_X_min;
    draw_X_max_current=draw_X_max;
 
    draw_Y_min=min_I_sign_only-(max_I_sign_only-min_I_sign_only)/10;
    draw_Y_max=max_I_sign_only+(max_I_sign_only-min_I_sign_only)/10;
    draw_Y_min_current=draw_Y_min;
    draw_Y_max_current=draw_Y_max;

    plot_x=mag;plot_y=I_sign_only; // display_mode==7
    ///////////////////////////////////////////////////////
   }  
   curC='D';
  } // if( curC=='M' || curC=='m' ){




  if( curC=='z' || curC=='Z' ){
   cpgband( 2, 0, curX, curY, &curX2, &curY2, &curC);
   draw_X_min_current=myfmin(curX,curX2);
   draw_X_max_current=myfmax(curX,curX2);
   draw_Y_min_current=myfmin(curY,curY2);
   draw_Y_max_current=myfmax(curY,curY2);
   
   if( curC=='Z' || curC=='z' )
    curC='D';
   else
    curC='R';
  }  
  if( curC=='D' || curC=='d' ){
   draw_X_min_current=draw_X_min;
   draw_X_max_current=draw_X_max;
   draw_Y_min_current=draw_Y_min;
   draw_Y_max_current=draw_Y_max;
  }


 }while( curC!='X' );

 // because of Nstar+1 allocation
 for(i=0;i<Nstar+1;i++)
  free(outfilename[i]);
 free(outfilename); 
 free(sigma);
 free(mag);
 free(X);
 free(Y);

 free(I);
 free(J);
 free(K);
 free(L);

 free(points_in_lightcurve);
 free(MAD_scaled_to_sigma);
 
 free(AGN_v);
 free(I_sign_only);
 free(Chi2);
 free(RoMS);
 free(lag1_autocorrelation);
 free(kurtosis);
 free(skewness);
 
 free(mag_viewed);
 free(sigma_viewed);

 free(modified_sigma);
 free(mark_as_viewed);
 free(mark_as_last_viewed);
 free(mark_as_candidate);
 
 //unsetenv("MALLOC_CHECK_");

 if( sigma_curve_N_points!=0 ){
  free(high_sigma_curve_mag);
  free(high_sigma_curve_limit);
  //
  free(high_sigma_curve_limit_modified_sigma);
  free(high_sigma_curve_limit_I);
  free(high_sigma_curve_limit_L);
 }
 
 cpgclos();
 
 return 0;
}
