
int fitsfile_read_check(char * fitsfilename){
        int status = 0; //for cfitsio routines
        fitsfile *fptr; // pointer to the FITS file; defined in fitsio.h 
        int hdutype;
        // check if this is a readable FITS file
        fits_open_file(&fptr, fitsfilename, READONLY, &status);
        if(0 != status)
         return status;
        if(fits_get_hdu_type(fptr, &hdutype, &status) || hdutype != IMAGE_HDU){
         fprintf(stderr,"%s is not a FITS image! Is it a FITS table?\n", fitsfilename);
         fits_close_file(fptr, &status);
         return 1;
        }
        fits_close_file(fptr, &status);
        return 0;
}


// Old version
/*
int fitsfile_read_check(char * fitsfilename){
        int status = 0; //for cfitsio routines
        fitsfile *fptr; // pointer to the FITS file; defined in fitsio.h 
        // check if this is a readable FITS file
        fits_open_file(&fptr, fitsfilename, READONLY, &status);
        if (0 != status)
                return status;
        fits_close_file(fptr, &status);
        return 0;
}
*/