#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <dirent.h>
#include <unistd.h>

#include "limits.h"

// if there is no vast_summary.log file - read all lightcurves to determine the maximum number of observations
int get_number_of_measured_images_from_lightcurves(){
 DIR *dp;
 struct dirent *ep;
 FILE *lightcurvefile;
 double jd,mag,merr,x,y,app;
 char string[FILENAME_LENGTH];
 
 int i,max_i;
 
 max_i=0;
 
 fprintf(stderr,"WARNING: in get_number_of_measured_images_from_lightcurves(): determining the maximum number of observations from the lightcurves!\n");
 
 dp = opendir ("./");
 if(dp != NULL){
  while( ep = readdir(dp) ){
   if( strlen(ep->d_name)<8 )continue; // make sure the filename is not too short for the following tests
   if( ep->d_name[0]=='o' && ep->d_name[1]=='u' && ep->d_name[2]=='t' && ep->d_name[strlen(ep->d_name)-1]=='t' && ep->d_name[strlen(ep->d_name)-2]=='a' && ep->d_name[strlen(ep->d_name)-3]=='d' ){
    lightcurvefile=fopen(ep->d_name,"r");
    if( NULL==lightcurvefile ){fprintf(stderr,"ERROR: Can't open file %s\n",ep->d_name);exit(1);}
    // Count observations 
    i=0;
    while(-1<fscanf(lightcurvefile,"%lf %lf %lf %lf %lf %lf %s",&jd,&mag,&merr,&x,&y,&app,string))i++;
    fclose(lightcurvefile);
    if(i>max_i)max_i=i;
   }
  }
  (void) closedir (dp);
 }
 else
  perror("Couldn't open the directory\n");
 return max_i; 
}

// if there is vast_summary.log - get numer of observations from it
int get_number_of_measured_images_from_vast_summary_log(){
 char str[1024];
 int n=0;
 FILE *vast_summary_log;
 vast_summary_log=fopen("vast_summary.log","r");
 if( vast_summary_log==NULL ){
  fprintf(stderr,"WARNING: in get_number_of_measured_images_from_vast_summary_log(): can't open vast_summary.log\n");
  n=get_number_of_measured_images_from_lightcurves();
  if( n==0 ){
   fprintf(stderr,"WARNING: cannot determine number of observations from the lightcurves.\nThis is a bad sign...\n");
   n=MAX_NUMBER_OF_OBSERVATIONS;
  }
  return n;
  //return TESTOR_MIN_NUMBER_OF_POINTS;
 }
 fscanf(vast_summary_log,"%s %s %d",str,str,&n);
 fscanf(vast_summary_log,"%s %s %s %s %d",str,str,str,str,&n);
 fclose(vast_summary_log);
 return n;
}
