/*
   This program should identify stars with large sigma.
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <gsl/gsl_sort.h>
#include <gsl/gsl_spline.h>
#include <gsl/gsl_statistics.h>
#include <gsl/gsl_errno.h>

#include "limits.h"
//#include "vast_math.h"

#include "stetson_variability_indexes.h"

/*
// see http://en.wikipedia.org/wiki/Robust_measures_of_scale
// and http://en.wikipedia.org/wiki/Median_absolute_deviation#relation_to_standard_deviation
double esimate_sigma_from_MAD_of_sorted_data( double * sorted_data, int n){
 double median_data,MAD,sigma;
 double * AD;
 int i;
 
 AD=malloc(n*sizeof(double));
 
 median_data=gsl_stats_median_from_sorted_data( sorted_data,1,n);
 for(i=0;i<n;i++){
  AD[i]=fabs(sorted_data[i]-median_data);
  //fprintf(stderr,"sorted_data[i]=%lf, median_data=%lf   AD=%lf\n",sorted_data[i],median_data,AD[i]);
 }
 gsl_sort( AD,1,n);
 MAD=gsl_stats_median_from_sorted_data( AD,1,n);
 
 free(AD);
 
 // 1.48260221850560 = 1/norminv(3/4)
 sigma=1.48260221850560*MAD;
 return sigma;
}
*/
//int main(int argc, char **argv){
int main(){
 FILE *sigma_selection_curve_log;
 FILE *dmsf;
 //double m,sigma,X,Y,sum,mmax,mean;
 double m,sigma,X,Y,mmax,mean;
 double *data_sigma;
 double *x_sigma;
 double *y;
 double *y_limit_sigma;
 y_limit_sigma=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 x_sigma=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 y=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 data_sigma=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 char str[256];
 //sum=-1;
 int n=0;
 int i=0;
 int n_drop_high_sigma_stars;

 double *data_modified_sigma;
 double *data_I;
 double *data_L;
 double modified_sigma_series,skewness,kurtosis,I,J,K,L;
 
 double *y_limit_modified_sigma;
 double *y_limit_I;
 double *y_limit_L;

 double *w;

 double lag1_autocorrelation,RoMS,Chi2,I_sign_only,AGN_v;
 
 //double a,b,old_mean;
 //a=b=2.0;
 
 data_modified_sigma=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 data_I=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 data_L=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 
 y_limit_modified_sigma=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 y_limit_I=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 y_limit_L=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 
 w=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);

 int n_modified_sigma,n_I,n_L;

 FILE * candidates_list;

// int j;
 
 double * m_arr;
 //double * x_modified_sigma;
 //double * x_I;
 //double * x_L;

 double MAD_scaled_to_sigma;
 int points_in_lightcurve;
 
 m_arr=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 
 //x_modified_sigma=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 //x_I=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 //x_L=malloc(sizeof(double)*MAX_NUMBER_OF_STARS);
 
/*
 dmsf=fopen("data.m_sigma","r");
 if( dmsf==NULL ){
  fprintf(stderr,"ERROR: Can't open data.m_sigma!\n");
  exit(1);
 }
*/

 dmsf=fopen("vast_lightcurve_statistics.log","r");
 if( dmsf==NULL ){
  fprintf(stderr,"ERROR: Can't open file vast_lightcurve_statistics.log !\n");
  exit(1);
 }

 
 i=0;n=0;mmax=0.0;
 while(-1<fscanf(dmsf,"%lf %lf %lf %lf %s  %lf  %lf %lf  %lf %lf %lf %lf %d %lf %lf %lf %lf %lf %lf",&m,&sigma,&X,&Y,str, &modified_sigma_series,&skewness,&kurtosis,&I,&J,&K,&L,&points_in_lightcurve,&MAD_scaled_to_sigma,&lag1_autocorrelation,&RoMS,&Chi2,&I_sign_only,&AGN_v)){

  if( mmax==0.0 )mmax=m;
/*
  if( sum==-1 ){
   sum=m;
   n=0;
   mmax=m;
  }

  // Force the splines to go throught the first point in every plot
  if( i==0 ){
   mmax=m;
   x[i]=m;
   y_limit_modified_sigma[i]=modified_sigma_series;
   y_limit_I[i]=I;
   y_limit_L[i]=L;
   y_limit_sigma[i]=sigma;
   i++;
  }
*/

  if( m<=mmax+M_SIGMA_BIN_SIZE_M || n<12 ){
   m_arr[n]=m;
   data_sigma[n]=sigma;
   data_modified_sigma[n]=modified_sigma_series;
   data_I[n]=I;
   data_L[n]=L;
   n++;
  }
  else{
   //
   n_modified_sigma=n;
   //sort_data_double(data_modified_sigma, 0, n_modified_sigma);
   gsl_sort2(data_modified_sigma, 1, m_arr, 1, n_modified_sigma);
   n_drop_high_sigma_stars=MAX((int)(0.07*n_modified_sigma),M_SIGMA_BIN_DROP);
   if( n_modified_sigma>2*n_drop_high_sigma_stars+2 )
    n_modified_sigma-=2*n_drop_high_sigma_stars;
   else
    if( n_modified_sigma>n_drop_high_sigma_stars+2 )
     n_modified_sigma-=n_drop_high_sigma_stars;
   mean=gsl_stats_median_from_sorted_data(data_modified_sigma,1,n_modified_sigma);
   
   //y_limit_modified_sigma[i]=gsl_stats_sd(data_modified_sigma,1,n_modified_sigma);
   //fprintf(stderr,"%lf  ",y_limit_modified_sigma[i]);
   y_limit_modified_sigma[i]=esimate_sigma_from_MAD_of_sorted_data(data_modified_sigma,n_modified_sigma);
   //fprintf(stderr,"%lf  \n",y_limit_modified_sigma[i]);

   if( 0!=isnan(y_limit_modified_sigma[i]) ){
    y_limit_modified_sigma[i]=0;
   }
   y_limit_modified_sigma[i]=mean+M_SIGMA_BIN_MAG_SIGMA_DETECT*y_limit_modified_sigma[i];
   //x_modified_sigma[i]=gsl_stats_mean(m_arr,1,n);
   //
   //
   n_I=n;
   //sort_data_double(data_I, 0, n_I);
   gsl_sort2(data_I, 1, m_arr, 1, n_I);
   //
   n_drop_high_sigma_stars=MAX((int)(0.07*n_I),M_SIGMA_BIN_DROP);
   if( n_I>2*n_drop_high_sigma_stars+2 )
    n_I-=2*n_drop_high_sigma_stars;
   else
    if( n_I>n_drop_high_sigma_stars+2 )
     n_I-=n_drop_high_sigma_stars;
   mean=gsl_stats_median_from_sorted_data(data_I,1,n_I);
   //y_limit_I[i]=gsl_stats_sd(data_I,1,n_I);
   y_limit_I[i]=esimate_sigma_from_MAD_of_sorted_data(data_I,n_I);
   if( 0!=isnan(y_limit_I[i]) ){
    y_limit_I[i]=0;
    //fprintf(stderr,"BUGGAGA\n");
   }
   y_limit_I[i]=mean+M_SIGMA_BIN_MAG_SIGMA_DETECT*y_limit_I[i];
   //x_I[i]=gsl_stats_mean(m_arr,1,n);
   //
   n_L=n;
   //sort_data_double(data_L, 0, n_L);
   gsl_sort2(data_L, 1, m_arr, 1, n_L);
   //
   n_drop_high_sigma_stars=MAX((int)(0.07*n_L),M_SIGMA_BIN_DROP);
   if( n_L>2*n_drop_high_sigma_stars+2 )
    n_L-=2*n_drop_high_sigma_stars;
   else
    if( n_L>n_drop_high_sigma_stars+2 )
     n_L-=n_drop_high_sigma_stars;
   ///
   //for(j=0;j<n_L;j++){fprintf(stderr,"%d  %lf\n",j,data_L[j]);}
   ///
   mean=gsl_stats_median_from_sorted_data(data_L,1,n_L);
   //y_limit_L[i]=gsl_stats_sd(data_L,1,n_L);
   y_limit_L[i]=esimate_sigma_from_MAD_of_sorted_data(data_L,n_L);
   //fprintf(stderr,"n_L=%d  %lf\n",n_L,y_limit_L[i]);
   if( 0!=isnan(y_limit_L[i]) ){
    y_limit_L[i]=0;
    //fprintf(stderr,"BUGGAGA\n");
   }
   y_limit_L[i]=mean+M_SIGMA_BIN_MAG_SIGMA_DETECT*y_limit_L[i];
   //x_L[i]=gsl_stats_mean(m_arr,1,n);
   //
   //sort_data_double(data_sigma, 0, n);
   gsl_sort2(data_sigma, 1, m_arr, 1, n);
   n_drop_high_sigma_stars=MAX((int)(0.07*n),M_SIGMA_BIN_DROP);
   // experimental
   if( n>2*n_drop_high_sigma_stars+2 )
    n-=2*n_drop_high_sigma_stars;
   else
    if( n>n_drop_high_sigma_stars+2 )
     n-=n_drop_high_sigma_stars;
   // end of experimental
   mean=gsl_stats_median_from_sorted_data(data_sigma,1,n); //gsl_stats_mean(data,1,n ); // would a median be more appropriate here?
   //x[i]=mmax+M_SIGMA_BIN_SIZE_M/2;
   x_sigma[i]=gsl_stats_mean(m_arr,1,n);
   //fprintf(stderr,"x[%d]=%lf\n",i,x[i]);
   y[i]=mean;
   y_limit_sigma[i]=gsl_stats_sd(data_sigma,1,n);
   if( 0!=isnan(y_limit_sigma[i]) ){
     y_limit_sigma[i]=0;
   }
   y_limit_sigma[i]=y[i]+M_SIGMA_BIN_MAG_SIGMA_DETECT*y_limit_sigma[i]; // now this is the detection limit

   //fprintf(stderr,"n=%d\n\n",n);

   i++;
   n=0;
   mmax=m;
  }
 }
 fclose(dmsf);

 // Debug
 //fprintf(stderr,"i=%d\n",i);

 // Interpolate
// fprintf(stderr,"DEBUG001\n");
 gsl_interp_accel *acc_sigma = gsl_interp_accel_alloc ();
 gsl_spline *spline_sigma = gsl_spline_alloc (gsl_interp_akima, i);
 gsl_spline_init (spline_sigma, x_sigma, y_limit_sigma, i);

// fprintf(stderr,"DEBUG002\n");
 gsl_interp_accel *acc_modified_sigma = gsl_interp_accel_alloc ();
 gsl_spline *spline_modified_sigma = gsl_spline_alloc (gsl_interp_akima, i);
 //gsl_spline_init (spline_modified_sigma, x_modified_sigma, y_limit_modified_sigma, i);
 gsl_spline_init (spline_modified_sigma, x_sigma, y_limit_modified_sigma, i);

// fprintf(stderr,"DEBUG003\n");
 gsl_interp_accel *acc_I = gsl_interp_accel_alloc ();
 gsl_spline *spline_I = gsl_spline_alloc (gsl_interp_akima, i);
 //gsl_spline_init (spline_I, x_I, y_limit_I, i);
 gsl_spline_init (spline_I, x_sigma, y_limit_I, i);

// fprintf(stderr,"DEBUG004\n");
 gsl_interp_accel *acc_L = gsl_interp_accel_alloc ();
 gsl_spline *spline_L = gsl_spline_alloc (gsl_interp_akima, i);
 //gsl_spline_init (spline_L, x_L, y_limit_L, i);
 gsl_spline_init (spline_L, x_sigma, y_limit_L, i);

 // Compute interpolating function and write it to file
 sigma_selection_curve_log=fopen("vast_sigma_selection_curve.log","w");
 if( sigma_selection_curve_log==NULL ){
  fprintf(stderr,"ERROR: Can't open file vast_sigma_selection_curve.log for writing!\n");
  exit(1);
 }
 double xi,yi;
 double yi_modified_sigma,yi_I,yi_L;
 for (xi = x_sigma[0]; xi < x_sigma[i-1]; xi += 0.01){
  yi = gsl_spline_eval (spline_sigma, xi, acc_sigma);
  yi_modified_sigma = gsl_spline_eval (spline_modified_sigma, xi, acc_modified_sigma);
  yi_I = gsl_spline_eval (spline_I, xi, acc_I);
  yi_L = gsl_spline_eval (spline_L, xi, acc_L);
  fprintf(sigma_selection_curve_log,"%lf %lf %lf %lf %lf\n",xi, yi, yi_modified_sigma, yi_I, yi_L);
 } 
 fclose(sigma_selection_curve_log);



 // ---------------------------------------------------------------------------------------------

 // Write stars which pass the selection criteria to data.m_sigma file
 dmsf=fopen("vast_lightcurve_statistics.log","r");
 if( dmsf==NULL ){
  fprintf(stderr,"ERROR: Can't open file vast_lightcurve_statistics.log for reading\n");
  exit(1);
 }
 /*
 candidates_list=fopen("vast_autocandidates.log","w");
 if( candidates_list==NULL ){
  fprintf(stderr,"ERROR: Can't open file vast_autocandidates.log for writing!\n");
  exit(1);
 }
 */
 while(-1<fscanf(dmsf,"%lf %lf %lf %lf %s  %lf  %lf %lf  %lf %lf %lf %lf %d %lf %lf %lf %lf %lf %lf",&m,&sigma,&X,&Y,str, &modified_sigma_series,&skewness,&kurtosis,&I,&J,&K,&L,&points_in_lightcurve,&MAD_scaled_to_sigma,&lag1_autocorrelation,&RoMS,&Chi2,&I_sign_only,&AGN_v)){
  //fprintf(stderr,"%lf %lf\n",m,sigma);
  // This should avoid "interpolation error" crash.
  if( m<x_sigma[0] )m=x_sigma[0];
  if( m>x_sigma[i-1] )m=x_sigma[i-1];
  // Compare the measured value with a limit
  if( sigma>=gsl_spline_eval(spline_sigma, m, acc_sigma) )
   fprintf(stdout,"%10.6lf %.6lf %9.3lf %9.3lf %s\n",m,sigma,X,Y,str);
  // New output to the files
  //if( sigma>gsl_spline_eval(spline_sigma, m, acc_sigma) && modified_sigma_series>gsl_spline_eval(spline_modified_sigma, m, acc_modified_sigma) && I>gsl_spline_eval(spline_I, m, acc_I) && L>gsl_spline_eval(spline_L, m, acc_L) )
  // fprintf(candidates_list,"%s\n",str);
 }
 //fclose(candidates_list);
 fclose(dmsf);

 free(y_limit_sigma);
 free(x_sigma);
 free(y);
 free(data_sigma);
 free(data_modified_sigma);
 free(data_I);
 free(data_L);
 free(w);

// free(x_modified_sigma);
// free(x_I);
// free(x_L);

 return 0;
}
